/* standart headers */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

/* pseudo VBI */
#include "psvbi.h"
#include "psvbid.h"

#define CLEAR(x) memset (&(x), 0, sizeof (x))

int main(int argc,char** argv)
{
    int i;
    struct psvbi_block test_block;
    void* frame;

    // 
    CLEAR(test_block);    

    // init mem space for frame
    printf("Allocating memory...");
    frame = malloc(PSVBID_FRAME_WIDTH*PSVBID_FRAME_HEIGHT*PSVBID_YPIXEL_SIZE);
    if(!(frame))
    {
        printf("Failed!\n");
        return -1;
    };
    printf("OK\n");

    // read file in mem
    printf("Opening file: %s ... ", argv[1]);
    FILE* f = fopen(argv[1],"rb");
    if(f == NULL)
    {
        printf("FAILED\n");
        return -1;
    };
    printf("OK\nReading data...");
    fread(frame,PSVBID_FRAME_WIDTH*PSVBID_FRAME_HEIGHT*PSVBID_YPIXEL_SIZE,1,f);
    printf("DONE\n");
    fclose(f);

    printf("Starting Decoding...\n");


    // #1
    printf("Data at offset #1\n");
    psvbi_load_Y(&test_block, frame, 0, PSVBID_LEVEL_COMPARE);
    psvbi_dump_block(&test_block);
    psvbi_decode(&test_block);
    psvbi_dump_block(&test_block);

    // #2
    printf("Data at offset #2\n");
    psvbi_load_Y(&test_block, frame, 0, PSVBID_LEVEL_COMPARE);
    psvbi_dump_block(&test_block);
    psvbi_decode(&test_block);
    psvbi_dump_block(&test_block);

    // #3
    printf("Searching....\n");
    CLEAR(test_block);
    psvbi_find_Y
    (
	&test_block, frame,
	0,10,
	0,10,
	PSVBID_FRAME_WIDTH, PSVBID_LEVEL_COMPARE
    );
    psvbi_dump_block(&test_block);

    printf("Decoding done!\n");
    // free memory of block
    free(frame);
    return 0;
};

