/* standart headers */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

/* pseud - VBI */
#include "psvbi.h"
#include "psvbid.h"

#define CLEAR(x) memset (&(x), 0, sizeof (x))

static unsigned char test_data[PSVBI_DATA_LEN + 1] = "Hellow_World!";

int main(int argc,char** argv)
{
    unsigned char* frame;
    int i;
    struct psvbi_block test_block;
    CLEAR(test_block);
    
    // init mem space for frame
    printf("Allocating memory...");
    frame = (unsigned char*)malloc(PSVBID_FRAME_WIDTH*PSVBID_FRAME_HEIGHT*PSVBID_YPIXEL_SIZE);
    if(!(frame))
    {
        printf("Failed!\n");
        return -1;
    };
    printf("OK\n");


    // create data block
    for(i=0;i<PSVBI_DATA_LEN;i++)
	test_block.decoded[i] = test_data[i];

    // dump?
    psvbi_dump_block(&test_block);

    // encode
    psvbi_encode(&test_block);

    // dump?
    psvbi_dump_block(&test_block);
    
    // store as Y components
    psvbi_save_Y(&test_block, frame, 0, PSVBID_LEVEL_SETUP);
    psvbi_save_Y(&test_block, frame, 2*PSVBID_FRAME_WIDTH, PSVBID_LEVEL_SETUP);

   
    // open file for saving
    printf("Opening file: %s ... ", argv[1]);
    FILE* f = fopen(argv[1],"wb");
    if(f == NULL)
    {
        printf("FAILED\n");
        return -1;
    }
    printf("OK\n");
    // write frame data
    printf("Writing data...");
    fwrite(frame, PSVBID_FRAME_WIDTH*PSVBID_FRAME_HEIGHT*PSVBID_YPIXEL_SIZE, 1, f);
    printf("DONE\n");
    // close file
    fclose(f);

    // free mem
    free(frame);
                                                                                                                                               
    return 0;
};

