#include <stdio.h>
#include "psvbi.h"
#include "psvbid-plugins.h"

#ifdef USE_SYSLOG
#include <syslog.h>
#warning syslog used
#else
#warning stdout used

#endif /* USE_SYSLOG */


void __attribute__ ((constructor)) my_init(void)
{
#ifdef USE_SYSLOG
    
    /* open syslog */
    openlog("psvbid::debug",LOG_PID | LOG_CONS,LOG_DAEMON);

    /* notify about start */    
    syslog(LOG_NOTICE,"my_init");

#else

    printf("debug::my_init\n");
    
#endif	/* USE_SYSLOG */
};

void __attribute__ ((destructor)) my_fini(void)
{
#ifdef USE_SYSLOG

    /* notify about stop */
    syslog(LOG_NOTICE,"my_fini");

    /* close log */
    closelog();

#else

    printf("debug::my_fini\n");

#endif	/* USE_SYSLOG */

};


static int detect_ok(struct psvbi_block* block)
{
    char buf[1024];

    // create dump of data
    sprintf
    (
        buf,
        "CORRECTIONS=%d,POS=[%d,%d], DATA=[%.2X %.2X %.2X %.2X %.2X %.2X %.2X %.2X %.2X %.2X %.2X %.2X %.2X %.2X]",
        block->corrections,
        block->_h,block->_v,
        (unsigned int)block->decoded[0],(unsigned int)block->decoded[1],(unsigned int)block->decoded[2],
        (unsigned int)block->decoded[3],(unsigned int)block->decoded[4],(unsigned int)block->decoded[5],
        (unsigned int)block->decoded[6],(unsigned int)block->decoded[7],(unsigned int)block->decoded[8],
        (unsigned int)block->decoded[9],(unsigned int)block->decoded[10],(unsigned int)block->decoded[11],
        (unsigned int)block->decoded[12],(unsigned int)block->decoded[13]
    );
 
#ifdef USE_SYSLOG
    syslog(LOG_NOTICE, buf);
#else
    printf("debug::detect_ok %s\n",buf);
#endif	/* USE_SYSLOG */
    
    return 0;
};


static int detect_fail(struct psvbi_block* block)
{
    return 0;
};


/* ---------------------------------------------------------------------------

    Define plugin attributest
    
----------------------------------------------------------------------------*/

struct psvbid_plugin PLUGIN = 
{
    .name = "debug",
    .ok = detect_ok,
    .fail = detect_fail
};

